using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;
using JUNKBOX.IO;

namespace captureTest
{
    public partial class Form1 : Form
    {
        int _count = 0; // R}

        CaptureDevice camera;
        public Form1()
        {
            InitializeComponent();

            // ׂẴLv`foCX擾
            VideoCapture capture = new VideoCapture();
            List<CaptureDevice> devices = capture.Devices;

            if (devices != null)
            {
                // 0Ԗڂ̃foCX擾
                camera = devices[0];
                this.toolStripStatusLabel1.Text = camera.Name;

                // 0Ԗڂ̃foCX 640x480 pixel  Bitmap o͂悤ɏ
                camera.Activate(this.previewPanel, 320, 240);
            }
            else
            {
                this.toolStripStatusLabel1.Text = "Lv`foCX܂ł";
                this.button1.Enabled = false;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (this.timer1.Enabled)
            {
                this.timer1.Stop();
            }
            else
            {
                _count = 0;
                this.timer1.Start();
            }
        }

        private void previewPanel_Resize(object sender, EventArgs e)
        {
            if (this.camera != null)
            {
              //  this.camera.ResizePreviewWindow();
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            // Î~Lv`
            Bitmap bmp = this.camera.Capture();

            // Bitmap  byte[] ɍϊ
            byte[] rgbValues = VideoCapture.BitmapToByteArray(bmp);

            // w肵邳ȏ̉f𔒂ɕύX
            for (int p = 0; p < rgbValues.Length; p += 4)
            {
                // p+0:B p+1:G p+2:R p+3:A

                // Fۂ
                if (rgbValues[p] > rgbValues[p + 1] && rgbValues[p] > rgbValues[p + 2]*2)
                {
                    // ԂœhԂ
                    rgbValues[p] = 0;       // 
                    rgbValues[p + 1] = 0;   // 
                    rgbValues[p + 2] = 255; // 
                }
                else
                {
                    // ȊO͍œhԂ
                    rgbValues[p] = 0;       // 
                    rgbValues[p + 1] = 0;   // 
                    rgbValues[p + 2] = 0;   // 
                }
            }

            // byte[]  Bitmap ɍϊ
            this.pictureBox1.Image = VideoCapture.ByteArrayToBitmap(rgbValues, bmp);
            timer1.Start();
            _count++;
            this.label1.Text = _count.ToString();
        }

    }
}